## ros-lunar-swri-image-util 2.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(swri_image_util)

find_package(catkin REQUIRED COMPONENTS
  camera_calibration_parsers
  cv_bridge
  geometry_msgs
  image_geometry
  image_transport
  message_filters
  nav_msgs
  nodelet
  roscpp
  rospy
  std_msgs
  swri_geometry_util
  swri_math_util
  swri_nodelet
  swri_opencv_util
  swri_roscpp
  tf
)

find_package(OpenCV REQUIRED)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Boost REQUIRED COMPONENTS filesystem system random)

# The Boost Random library headers and namespaces changed between version
# 1.46 and 1.47
if(${Boost_LIB_VERSION} MATCHES "1_46*")
  add_definitions( -DBOOST_1_46 )
endif(${Boost_LIB_VERSION} MATCHES "1_46*")

find_package(Eigen3)
if(NOT EIGEN3_FOUND)
  # Fallback to pkg-config
  find_package(PkgConfig)
  pkg_check_modules(EIGEN3 REQUIRED eigen3)
else()
  set(EIGEN3_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
endif()
add_definitions(${EIGEN3_DEFINITIONS})

catkin_package(
  DEPENDS OpenCV EIGEN3
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS
    camera_calibration_parsers
    cv_bridge
    geometry_msgs
    image_geometry
    image_transport
    message_filters
    nav_msgs
    nodelet
    roscpp
    rospy
    std_msgs
    swri_math_util
    swri_opencv_util
    swri_roscpp
    tf
)

include_directories(include
  ${catkin_INCLUDE_DIRS}
  ${OpenCV_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

add_library(${PROJECT_NAME}
  src/draw_util.cpp
  src/geometry_util.cpp
  src/image_matching.cpp
  src/image_normalization.cpp
  src/image_warp_util.cpp
  src/replace_colors.cpp
  src/rolling_normalization.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${OpenCV_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_library(${PROJECT_NAME}_nodelets
  src/nodelets/blend_images_nodelet.cpp
  src/nodelets/crosshairs_nodelet.cpp
  src/nodelets/contrast_stretch_nodelet.cpp
  src/nodelets/draw_polygon_nodelet.cpp
  src/nodelets/draw_text_nodelet.cpp
  src/nodelets/image_pub_nodelet.cpp
  src/nodelets/normalize_response_nodelet.cpp
  src/nodelets/replace_colors_nodelet.cpp
  src/nodelets/rotate_image_nodelet.cpp
  src/nodelets/scale_image_nodelet.cpp
  src/nodelets/warp_image_nodelet.cpp
)
target_link_libraries(${PROJECT_NAME}_nodelets ${PROJECT_NAME})

add_executable(blend_images src/nodes/blend_images_node.cpp)
target_link_libraries(blend_images ${catkin_LIBRARIES})

add_executable(contrast_stretch src/nodes/contrast_stretch.cpp)
target_link_libraries(contrast_stretch ${catkin_LIBRARIES})

add_executable(draw_text src/nodes/draw_text.cpp)
target_link_libraries(draw_text ${catkin_LIBRARIES})

add_executable(dummy_image_publisher src/nodes/dummy_image_publisher.cpp)
target_link_libraries(dummy_image_publisher ${catkin_LIBRARIES})

add_executable(normalization_image_generator_node src/nodes/normalization_image_generator_node.cpp)
target_link_libraries(normalization_image_generator_node ${PROJECT_NAME})

add_executable(normalize_response src/nodes/normalize_response.cpp)
target_link_libraries(normalize_response ${catkin_LIBRARIES})

add_executable(rotate_image src/nodes/rotate_image.cpp)
target_link_libraries(rotate_image ${catkin_LIBRARIES})

add_executable(scale_image src/nodes/scale_image.cpp)
target_link_libraries(scale_image ${catkin_LIBRARIES})

add_executable(replace_colors src/nodes/replace_colors.cpp)
target_link_libraries(replace_colors ${catkin_LIBRARIES})

swri_nodelet_add_node(draw_polygon ${PROJECT_NAME} DrawPolygonNodelet)
target_link_libraries(draw_polygon ${PROJECT_NAME}_nodelets ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})

swri_nodelet_add_node(image_pub ${PROJECT_NAME} ImagePubNodelet)
target_link_libraries(image_pub ${PROJECT_NAME}_nodelets ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})

swri_nodelet_add_node(warp_image ${PROJECT_NAME} WarpImageNodelet)
target_link_libraries(warp_image ${PROJECT_NAME}_nodelets ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})

swri_nodelet_add_node(crosshairs ${PROJECT_NAME} CrosshairsNodelet)
target_link_libraries(crosshairs ${PROJECT_NAME}_nodelets ${OpenCV_LIBRARIES} ${catkin_LIBRARIES})

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest_gtest(test_geometry_util test/geometry_util.test test/test_geometry_util.cpp)
  target_link_libraries(test_geometry_util ${PROJECT_NAME})
endif()

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(TARGETS ${PROJECT_NAME}
    ${PROJECT_NAME}_nodelets
    blend_images
    contrast_stretch
    crosshairs
    draw_polygon
    draw_text
    dummy_image_publisher
    image_pub
    normalization_image_generator_node
    normalize_response
    replace_colors
    rotate_image
    scale_image
    warp_image
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-lunar-swri-image-util (2.9.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Thu, 23 May 2019 05:00:00 -0000

ros-lunar-swri-image-util (2.8.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Wed, 06 Feb 2019 06:00:00 -0000

ros-lunar-swri-image-util (2.7.3-1stretch) stretch; urgency=high

  * Fixes for image normalization. (#536 <https://github.com/swri-robotics/marti_common/issues/536>)
  * Contributors: Marc Alban

 -- Kris Kozak <kkozak@swri.org>  Thu, 03 Jan 2019 06:00:00 -0000

ros-lunar-swri-image-util (2.7.2-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Thu, 20 Dec 2018 06:00:00 -0000

ros-lunar-swri-image-util (2.7.1-1stretch) stretch; urgency=high

  * Fix masked image normalization. (#531 <https://github.com/swri-robotics/marti_common/issues/531>)
  * Contributors: Marc Alban

 -- Kris Kozak <kkozak@swri.org>  Fri, 14 Dec 2018 06:00:00 -0000

ros-lunar-swri-image-util (2.7.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Tue, 04 Dec 2018 06:00:00 -0000

ros-lunar-swri-image-util (2.6.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Sat, 03 Nov 2018 05:00:00 -0000

ros-lunar-swri-image-util (2.5.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Fri, 12 Oct 2018 05:00:00 -0000

ros-lunar-swri-image-util (2.4.0-1stretch) stretch; urgency=high

  * Add function to blend two images with alpha channels. (#522 <https://github.com/swri-robotics/marti_common/issues/522>)
  * Contributors: Marc Alban

 -- Kris Kozak <kkozak@swri.org>  Tue, 09 Oct 2018 05:00:00 -0000

ros-lunar-swri-image-util (2.3.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Fri, 25 May 2018 05:00:00 -0000

ros-lunar-swri-image-util (2.2.1-1stretch) stretch; urgency=high

  * Initialize image before drawing on it. (#512 <https://github.com/swri-robotics/marti_common/issues/512>)
  * Contributors: Marc Alban

 -- Kris Kozak <kkozak@swri.org>  Fri, 11 May 2018 05:00:00 -0000

ros-lunar-swri-image-util (2.2.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Mon, 12 Feb 2018 06:00:00 -0000

ros-lunar-swri-image-util (2.1.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Fri, 26 Jan 2018 06:00:00 -0000

ros-lunar-swri-image-util (2.0.0-1stretch) stretch; urgency=high

  * Add nodelet for drawing a polygon on an image. (#500 <https://github.com/swri-robotics/marti_common/issues/500>)
  * update to use non deprecated pluginlib macro (#493 <https://github.com/swri-robotics/marti_common/issues/493>)
  * Implement simple image file publisher. (#488 <https://github.com/swri-robotics/marti_common/issues/488>)
  * Contributors: Marc Alban, Mikael Arguedas

 -- Kris Kozak <kkozak@swri.org>  Mon, 18 Dec 2017 06:00:00 -0000

ros-lunar-swri-image-util (1.2.0-1stretch) stretch; urgency=high



 -- Kris Kozak <kkozak@swri.org>  Fri, 13 Oct 2017 05:00:00 -0000

ros-lunar-swri-image-util (1.1.0-1stretch) stretch; urgency=high

  * Improving user feedback when checking parameter validity. Breaking apart parameter checks so it is clearer what the error is. Also making sure the user passes in non-negative values for RGB and gray values
  * Add a crosshairs nodelet to swri_image_util (#461 <https://github.com/pjreed/marti_common/issues/461>)
  * Cloning OpenCV matrices to make sure values are not overwritten
  * Fixing conditions which would trigger a warning on node startup
  * Fixing problems caused by OpenCV matrices making shallow copies
  * Adding compiler flag to correctly include file when using OpenCV 2.x
  * Adding ability to recolor image using an OpenCV colormap
  * Improving robustness of parameter parsing
  * Improving error checking
  * Adding color replacer to nodelet list
  * Contributors: David Anthony, Edward Venator, Jerry Towler, Marc Alban, P. J. Reed

 -- Kris Kozak <kkozak@swri.org>  Thu, 31 Aug 2017 05:00:00 -0000

ros-lunar-swri-image-util (1.0.0-1stretch) stretch; urgency=high

  * Create warp_image Nodelet (#446 <https://github.com/evenator/marti_common/issues/446>)
    Add a nodelet to swri_image util that applies a 3x3 transformation matrix to an image using cv::warpPerspective and publishes the resulting image.
  * Contributors: Edward Venator

 -- Kris Kozak <kkozak@swri.org>  Wed, 02 Aug 2017 05:00:00 -0000

ros-lunar-swri-image-util (0.3.0-1stretch) stretch; urgency=high

  * Merge together the indigo, jade, and kinetic branches (#443 <https://github.com/pjreed/marti_common/issues/443>)
  * Enable blending with transparency mask (#439 <https://github.com/pjreed/marti_common/issues/439>)
  * Contributors: Jerry Towler, P. J. Reed

 -- Kris Kozak <kkozak@swri.org>  Tue, 20 Jun 2017 05:00:00 -0000

ros-lunar-swri-image-util (0.2.4-1stretch) stretch; urgency=high

  * Image blending kinetic (#429 <https://github.com/swri-robotics/marti_common/issues/429>)
  * Initial commit of image blending
  * Adding launch file and various bug fixes
  * Making the base and top image encoding match. Lets us do things like blend a grayscale image onto a color image
  * Removing file globbing from CMakeLists that made QtCreator happy
  * Adding message_filters as a ROS package dependency
  * Fix issue with contrast stretching when a grid cell is completely masked out.
  * Contributors: Marc Alban, danthony06

 -- Kris Kozak <kkozak@swri.org>  Tue, 11 Apr 2017 05:00:00 -0000

ros-lunar-swri-image-util (0.2.3-1stretch) stretch; urgency=high

  * Fix OpenCV dependencies for Kinetic build (#400 <https://github.com/swri-robotics/marti_common/issues/400>)
  * Contributors: P. J. Reed

 -- Kris Kozak <kkozak@swri.org>  Fri, 09 Dec 2016 06:00:00 -0000

ros-lunar-swri-image-util (0.2.2-1stretch) stretch; urgency=high

  * Fix issue with contrast stretching when a grid cell is completely masked out.
  * Migrated OpenCV to 3.1 (default in Kinetic)
  * Contributors: Brian Holt, Marc Alban



=== debian/control ===
Source: ros-lunar-swri-image-util
Section: misc
Priority: extra
Maintainer: Kris Kozak <kkozak@swri.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, pkg-config, ros-lunar-camera-calibration-parsers, ros-lunar-catkin, ros-lunar-cv-bridge, ros-lunar-geometry-msgs, ros-lunar-image-geometry, ros-lunar-image-transport, ros-lunar-message-filters, ros-lunar-nav-msgs, ros-lunar-nodelet, ros-lunar-roscpp, ros-lunar-rospy, ros-lunar-rostest, ros-lunar-std-msgs, ros-lunar-swri-geometry-util, ros-lunar-swri-math-util, ros-lunar-swri-nodelet, ros-lunar-swri-opencv-util, ros-lunar-swri-roscpp, ros-lunar-tf
Homepage: https://github.com/swri-robotics/marti_common
Standards-Version: 3.9.2

Package: ros-lunar-swri-image-util
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-lunar-camera-calibration-parsers, ros-lunar-cv-bridge, ros-lunar-geometry-msgs, ros-lunar-image-geometry, ros-lunar-image-transport, ros-lunar-message-filters, ros-lunar-nav-msgs, ros-lunar-nodelet, ros-lunar-roscpp, ros-lunar-rospy, ros-lunar-std-msgs, ros-lunar-swri-geometry-util, ros-lunar-swri-math-util, ros-lunar-swri-opencv-util, ros-lunar-swri-roscpp, ros-lunar-tf
Description: swri_image_util

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-swri-image-util//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
